{% extends 'shared/layout.html' %}
{% load static %}
<!-- Load custom filters from shared app, including ISO 8901 Date-Time Converter -->
{% load custom_filters %}
<!-- Load markdownify -->
{% load markdownify %}
<!-- Start Page Render -->
<!-- Extra links block for pages that have a user_identifier piped to them.-->
{% block extra_links %}
  {% include 'shared/extend_sidebar.html' %}
{% endblock %}

{% block h3 %}
  {% if results.issue %}
  </h3>
  <div class="row justify-content-between">
    <p class="col-auto mb-0 small pb-0 pt-0">
      {% if results.issue.created_at %}
      <a href="{{results.go_back_url}}">
        {{results.project.name_with_namespace}}
      </a> 
      ({{results.project.id}}) / issues / #{{results.issue.iid}}
      {% endif %}
    </p>
    <p class="col-auto text-muted small mb-0 pb-0 pt-0 text-right">
      {% if results.issue.created_at %}
      Created {{results.issue.created_at|pretty_datetime}} by @{{results.issue.author.username}}
      {% else %}
      {% endif %}
    </p>
  </div>
  <hr class="mb-0 mt-0">
  <div class="row justify-content-between">
    {% if results.issue.created_at %}
    <div class="col-auto">
      <p class="mb-0 small pb-0 pt-0">
      {% if results.issue.milestone.title %}
      Milestone: {{results.issue.milestone.title}}.
      {% else %}
      Milestone: <span class="text-muted">(None Assigned.)</span>
      {% endif %}
      </p>
    </div>
  <!-- Generate Links Badges and Labels Pill-Badges -->
    <div class="col-auto">
      <p class="text-muted small mb-0 pb-0 pt-0 text-right">
        {% for label in results.issue.labels %}
        <span class="badge-pill badge-primary mr-1 mt-1">{{label}}</mark></span>
        {% endfor %}
        <!-- Back to Project Badge -->
        <a class="btn btn-sm btn-outline-primary ml-4 px-1 py-0" href="{{results.go_back_url}}">Back To Project</a>
        <!-- Generate See on Gitlab button   -->
        <a class="btn btn-sm btn-outline-primary ml-2 px-1 py-0" href="{{results.issue.web_url}}" target="__blank">See on Gitlab</a>
        <!-- Create Note Badge -->
        <a class="btn btn-sm btn-primary bg success ml-2 px-1 py-0" href="{{results.new_note_link}}">New Note</a> 
      </p>
    </div>
    {% endif %}
  </div>
  <div class="row  mt-5">
    <div class="col-12">
      <h4><span class="badge badge-primary mr-2">
        {% if results.issue.state == "closed" %}
        {{results.issue.state|capfirst}}
        {% else %}
        {{results.issue.state|capfirst|slice:"-2"}}
        {% endif %}
      </span>{{results.issue.title|capfirst}}</h4>
    </div>
  <div class="col-12 small mt-0 mb-3 text-right">

  </div>
</div>
  {% else %}
    Issue Not Found
  {% endif %}
{% endblock %}
{% block subheader %} 
  <p class="small short-height">{{results.issue.description|capfirst|markdownify}}</p>
{% endblock %}

{% block content %}

<!-- Issue Summary Block -->
{% if results.issue.updated_at %}
  <div class="row mt-3">
    <div class="col-12">
      <h4 class="card-title">Issue Summary</h4>
      <ul>
        <li><span class="text-muted">Currently Assigned To:</span> @{{results.issue.assignee.username}}.
        <span class="text-muted ml-1">Due Date:</span> {{results.issue.due_date|pretty_datetime}}.
        <span class="text-muted ml-1">Last Updated:</span> {{results.issue.updated_at|pretty_datetime}}</li>
      </ul>
    </div>
  </div>
{% else %}
{% endif %}
<!-- Generate a Back to Landing URL Link -->
{% url 'user-landing' as go_back_url %}
<div>
  <p>
    You can <a href="{{go_back_url}}">go back to your landing page</a>
    {% if results.issue.updated_at%} 
    or
    <!-- New_note_link is generated in views.py. -->
    <a href="{{results.new_note_link}}">create a new note</a> for this issue.
    {% else %}.{% endif %}
  </p>
</div>

<!-- Notes Block -->
<!-- Note Header Block -->
<div class="row mt-5">
  <div class="col-12 p-2">
    <h4 class="card-title">Issue Notes</h4>
  </div>
</div>

<!-- If notes, iterate through them and display cards. -->
<div class="p2 bg-light">
  {% if results.notes %}
  {% for note in results.notes %}
  <div class="row">
    <div class="col-12 p-2">
      <div class="card mb-2">
        <div class="card-body">
          {% if note.author %}
          <p class="card-text text-muted">
            {{note.noteable_type|title}} 
            note by @{{note.author.username}}, 
            Created: {{note.created_at|pretty_datetime}}, 
            Last Updated: {{note.updated_at|pretty_datetime}}
          </p>
          {% else %}{% endif %}
          <p class="card-text">{{note.body|markdownify}}</p>
        </div>
      </div>
    </div>
  </div>
  {% endfor %}
  {% else %}
  <!-- If no notes, generate a "No notes block". -->
  <div class="row">
    <div class="col-12 p-2">
      <div class="card mb-2">
        <div class="card-body">
          <p class="card-text text-muted">
            There are no notes for this issue at this time.
          </p>
        </div>
      </div>
    </div>
  </div>
  {% endif %}
</div>
{% endblock %}